<?php

namespace Apps\Booking\Widget\BookingReservationForm;

use Core\Control\Form\Form;
use Core\View\View;
use Core\View\ElementView;
use Apps\Booking\Decorator\CaracteristiqueDecorator;

class BookingReservationForm extends Form {

    /**
     * Constructeur
     */
    function __construct($core = "", $data = "") {
        $this->Core = $core;
        $this->Data = $data;

        $this->Init($data);
    }

    /**
     * Initialisation 
     */
    function Init($data) {
        $this->form = new Form("BookingReservationFormForm", $data);

        $this->form->SetView(__DIR__ . "/View/index.tpl", $this->Core);
        $this->form->SetAction("/View/index.tpl");

        $this->form->Add(array("Type" => "Hidden",
            "Id" => "Id",
        ));
        
        $this->form->Add(array("Type" => "TextBox",
            "Id" => "FirstName",
            "Validators" => ["Required"]
        ));
        
        $this->form->Add(array("Type" => "TextBox",
        "Id" => "Name",
        "Validators" => ["Required"]
        ));

        $this->form->Add(array("Type" => "EmailBox",
        "Id" => "Email",
        "Validators" => ["Required"]
        ));

        $this->form->Add(array("Type" => "TextBox",
        "Id" => "Tel",
        "Validators" => ["Required"]
        ));

        $this->form->Add(array("Type" => "DateBox",
        "Id" => "DateStart",
        "Validators" => ["Required"]
        ));

        $this->form->Add(array("Type" => "DateTimeBox",
        "Id" => "HourStart",
        "Validators" => ["Required"]
        ));

        $caracteristiqueDecorator = new CaracteristiqueDecorator($this->Core);
        $this->form->AddElementView(new ElementView("Caracteristiques", $caracteristiqueDecorator->RenderCaracteristiques()));

        $this->form->Add(array("Type" => "Button",
            "Id" => "btnValidReservation",
            "Value" => $this->Core->GetCode("Booking.ValidReservation"),
            "CssClass" => "btn btn-primary"
        ));
    }

    /*     * *
     * Render the html form
     */

    function Render() {
        return $this->form->Render();
    }

    /*     * *
     * Validate the data
     */

    function Validate($data = "") {
        $errors = $this->form->Validate($this->Data);

        return $errors;
    }

    /*     * *
     * Load control with the entity
     */

    function Load($entity) {
        $this->form->Load($entity);
    }

    /*     * *
     * Populate the entity with the form Data
     */

    function Populate($entity) {
        
    }

    /*     * *
     * Error message
     */

    function Error() {
        $errors[] = $this->form->errors;

        return json_encode(array("statut" => "Error", "message" => $errors));
    }

}
